<template>
	<div class="FieldsViewStatusFilter">
		<div class="FieldsViewStatusFilter-header">
			<h4>Filter by Status</h4>
			<template v-if="!useDesktopLayout">
				<v-spacer></v-spacer>
				<button class="FieldsViewStatusFilter-clear primary--text" @click="clearFilter">Clear filter</button>
			</template>
		</div>
		<v-divider></v-divider>
		<v-radio-group v-model="statusFilter">
			<v-radio v-for="option in statusOptions" :key="option.value" :value="option.value" :label="option.label">
			</v-radio>
		</v-radio-group>
		<template v-if="useDesktopLayout">
			<v-divider></v-divider>
			<div class="FieldsViewStatusFilter-footer">
				<button class="FieldsViewStatusFilter-clear primary--text" @click="clearFilter">Clear filter</button>
				<button class="FieldsViewStatusFilter-ok primary--text" @click="$emit('ok')">OK</button>
			</div>
		</template>
	</div>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';
import { StatusState } from '@/store/types';

const statusOptions: Array<{ value: StatusState; label: string }> = [
	{ value: 'posted', label: 'Posted' },
	{ value: 'stratified', label: 'Stratified' },
	{ value: 'sampled', label: 'Sampled' },
];

export default defineComponent({
	emits: ['ok'],
	props: {
		useDesktopLayout: {
			type: Boolean,
			default: false,
		},
	},
	setup(_, { root }) {
		const statusFilter = computed({
			get: () => root.$store.getters['fieldsView/getStatusFilter'],
			set: (value: StatusState) => root.$store.dispatch('fieldsView/setStatusFilter', value),
		});

		const clearFilter = () => {
			root.$store.dispatch('fieldsView/setStatusFilter', null);
		};

		return {
			statusFilter,
			clearFilter,
			statusOptions,
		};
	},
});
</script>

<style>
.FieldsViewStatusFilter {
	padding: 6px 8px;
	background: #fff;
}

.FieldsViewStatusFilter-header {
	display: flex;
}

.FieldsViewStatusFilter .v-input--radio-group {
	margin-top: 0;
}

.FieldsViewStatusFilter .v-input--radio-group .v-messages {
	display: none;
}

.FieldsViewStatusFilter .v-divider {
	margin: 4px 0 8px 0;
}

.FieldsViewStatusFilter-footer {
	display: flex;
	justify-content: space-between;
}
</style>
